//procedury dostepu do danych w EEPROM ESP8266
#include "ObslugaEEPROM.h"
#include <EEPROM.h>

//zapis do EEPROM nazwy sieci SSID
bool EEPROM_Zapis_SSID(char *p_buf_SSID)
{
int x, ile;
   
  char *p_poz =strchr(p_buf_SSID, '\n');
  //if (p_poz !=NULL) *p_poz ='\0';
  ile =(p_poz-p_buf_SSID);
  if (ile>=SIEC_NAZWA_ROZMIAR-1) return false;
  EEPROM.begin(SIEC_NAZWA_ROZMIAR);
  delay(10);
  for (x=SIEC_NAZWA_ADR;x<SIEC_NAZWA_ADR+ile;x++)
  {
    EEPROM.write(x, *p_buf_SSID);
    p_buf_SSID++;
  }
  EEPROM.write(x, '\0');
  EEPROM.commit();
  EEPROM.end();
  return true;
}

//zapis do EEPROM hasła sieci
bool EEPROM_Zapis_Hasla(char *p_buf_hasla)
{
int x, ile;
      
  char *p_poz =strchr(p_buf_hasla, '\n');
  //if (p_poz !=NULL) *p_poz ='\0';
  ile =(p_poz-p_buf_hasla);
  if (ile>=SIEC_HASLO_ROZMIAR-1) return false;
  EEPROM.begin(SIEC_HASLO_ADR+SIEC_HASLO_ROZMIAR);
  delay(10);
  for (x=SIEC_HASLO_ADR;x<SIEC_HASLO_ADR+ile;x++)
  {
    EEPROM.write(x, *p_buf_hasla);
    p_buf_hasla++;
  }
  EEPROM.write(x, '\0');
  EEPROM.commit();
  EEPROM.end();
  return true;
}

//odczyt z EEPROM nazwy sieci SSID
void EEPROM_Odczyt_SSID(char *p_buf_SSID)
{
int x;

  EEPROM.begin(SIEC_NAZWA_ROZMIAR);
  delay(10);
  for (x=SIEC_NAZWA_ADR;x<SIEC_NAZWA_ADR+SIEC_NAZWA_ROZMIAR-1;x++)
  {
    *p_buf_SSID =EEPROM.read(x);
    if (*p_buf_SSID =='\0')
    {
      p_buf_SSID++;
      break;
    }
    p_buf_SSID++;
  }
  *p_buf_SSID = '\0';
  EEPROM.end();
}

//odczyt z EEPROM hasla sieci
void EEPROM_Odczyt_Hasla(char *p_buf_hasla)
{
int x;

  EEPROM.begin(SIEC_HASLO_ADR+SIEC_HASLO_ROZMIAR);
  delay(10);
  for (x=SIEC_HASLO_ADR;x<SIEC_HASLO_ADR+SIEC_HASLO_ROZMIAR-1;x++)
  {
    *p_buf_hasla =EEPROM.read(x);
    if (*p_buf_hasla =='\0')
    {
      p_buf_hasla++;
      break;
    }
    p_buf_hasla++;
  }
  *p_buf_hasla = '\0';
  EEPROM.end();
}

