//Procedury tagów
#include "Formatowanie_SHTML.h"

//-------------------------------------
//procedura obsługi tagów-w w pliku SHTML
void Procedura_Tagow_SHTML(char *p_buf)
{
const char tag_ini_tab[]=  {"<!--#"};
const char tag_stop_tab[]=  {"-->"};
const char tag_list_tab[][16]=  {{TAG_W_IN1}, {TAG_W_IN2}, {TAG_W_IN3}, {TAG_W_IN4}, 
                                 {TAG_W_OUT1},{TAG_W_OUT2},{TAG_W_OUT3},{TAG_W_OUT4},{TAG_W_HAS1},{"adc1"},{"dac1"},
                                 {TAG_W_TXT1}};

char *p_bufor, *p_start, *p_start1, *p_stop, *p_tag;
char x, buf_tmp1[20];
int typ_tagu;
bool tag_wazny=false;

  p_bufor =p_buf;
  while (1)
  {
    //sprawdzenie czy dane w buforze zawierają sekwencję inicjującą tag
    p_start =strstr(p_bufor, &tag_ini_tab[0]);
    if (p_start ==NULL) return;//brak sekwencji otwierającej tag
    p_stop =strstr(p_start, &tag_stop_tab[0]);
    if (p_stop ==NULL) return;//brak sekwencji zamykającej tag
    p_start1 =p_start +strlen(&tag_ini_tab[0]);
    //przepisanie do buf_tmp1[] etykiety tagu składającej się ze znaków alfanumerycznych i podkreślenia
    x=0;
    while ((isalnum(*p_start1) || *p_start1 =='_') && x<21)
    {
      buf_tmp1[x] =*p_start1;
      p_start1++;
      x++;  
    }
    buf_tmp1[x] ='\0';
    typ_tagu =0;
    while (typ_tagu < ILE_TAGOW_W)
    {
      p_tag =strstr(&tag_list_tab[typ_tagu][0], &buf_tmp1[0]);
      if (p_tag !=NULL) break;//tag odnaleziony
      typ_tagu++;
    }
    tag_wazny =false;
    //obsługa tagów
    switch (typ_tagu)
    {
      case IN1_TAG:
      case IN2_TAG:
      case IN3_TAG:
      case IN4_TAG:
      {
        tag_wazny =Warunki_Tagow_IO_WE(typ_tagu,p_start1); 
        break;
      }
      case OUT1_TAG:
      case OUT2_TAG:
      case OUT3_TAG:
      case OUT4_TAG:
      {
        tag_wazny =Warunki_Tagow_IO_WY(typ_tagu,p_start1);
        break;
      }
      case TXT1_TAG:
      {
        tag_wazny =Warunek_Tagu_txt1(p_start1, p_stop);
        break;
      }
      
      default:
      {
        break;//dziwny błąd, nie obsługiwany tag
      }
    }
    //jeżeli tag ważny spacje zamiast komentarza
    if (tag_wazny ==true)
    {
      while(*p_start !=' ')
      {
        *p_start =' ';
        p_start++;
      }
      memset(p_stop, ' ', strlen(&tag_stop_tab[0]));
    }
    //kolejna pętla poszukiwania
    p_bufor =p_stop;
  }
}
//-------------
//obsługa danych/tagów-f przesłanych z komunikatem GET lub POST
void Obsluga_Komunikatu(char *p_buf)
{
const char tag_list_wyjsc_tab[][21]=  {{TAG_F_OUT1},{TAG_F_OUT2},{TAG_F_OUT3},{TAG_F_OUT4},{TAG_F_HAS1},{"dac1"},
                                       {TAG_F_NET_SSID},{TAG_F_NET_HAS}};
char *p_buf_tmp, *p_poz, *p_poz_par, x;
bool flaga;

  p_buf_tmp =p_buf;
  //obsluga_przeslania_pliku.haslo_Serwera_prawidlowe =FALSE;
  x=0;  
  //sprawdzenie czy z komunikatem przesłano tag
  while (1)
  {
    for (x=0; x<ILE_TAGOW; x++)
    {
      p_poz =strstr(p_buf_tmp, &tag_list_wyjsc_tab[x][0]);
      if (p_poz !=NULL) break;//tag zidentyfikowany
    }
    if (x==ILE_TAGOW) return;//brak tagów w komunikacie
    //*(p_poz-1) ='\0';//zastêpowanie '?' rozdzielaj¹cego nazwê strony HTML od parametru znakiem '\0'
    p_poz++;
    p_poz_par =strchr(p_poz, '=');
    if (p_poz_par ==NULL) return;//brak znaku '=' pomiędzy tagiem wyjscia a parametrem
    p_poz_par++;//wskaźnika na pierwszy znak parametru
    //obsługa wyjścia
    switch (x)
    {
      case OUT1_STR:
      case OUT2_STR:
      case OUT3_STR:
      case OUT4_STR:
      {
        Ustawianie_IO_WY(x, p_poz_par);
        break;
      }
      /*
      case HAS1_STR:
      {
        flaga =Kontrola_Przeslanego_Hasla_Serwera(HAS1_STR, p_poz_par);
        obsluga_przeslania_pliku.haslo_Serwera_prawidlowe =flaga;
        if (flaga ==TRUE)
        {
          //has³a zgodne, ustawienie docelowej nazwy strony, która zostanie otwarta
          *p_buf ='/';
          EepOdczyt(EEP_ADR_STRO_PO_PRAW_HASLE_SERW, ILE_BAJTOW_HASLA_SERW_MAX, p_buf+1);
          *(p_buf+ILE_BAJTOW_HASLA_SERW_MAX) ='\0';
          p_buf_tmp=strchr(p_buf, '\n');
          if (p_buf_tmp !=NULL) *p_buf_tmp ='\0';
          p_buf_tmp=strchr(p_buf, '\r');
          if (p_buf_tmp !=NULL) *p_buf_tmp ='\0';
          return;
        }
        break;
      }
      case DAC1_STR:
      {
        Konwersja_DAC1(DAC1_STR, p_poz_par);
        break;
      }*/
      case NET_SSID:
      {
        EEPROM_Zapis_SSID(p_poz_par);
        break;
      }
      case NET_HAS:
      {
        EEPROM_Zapis_Hasla(p_poz_par);
        break;
      }
      default:
      {
        break;//błąd, nie obsługiwany tag
      }
    }
    p_buf_tmp =p_poz;//pętla poszukiwania kolejnego tagu
  }

}

